"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Content = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _compile = require("../plugins/compile");

const _excluded = ["content", "excerpt", "renderers", "data", "prefix", "raw", "component"];

const Content = /*#__PURE__*/_react.default.forwardRef(function Content(fwdProps, ref) {
  const {
    content,
    excerpt,
    renderers,
    data,
    prefix,
    raw,
    component
  } = fwdProps,
        componentProps = (0, _objectWithoutProperties2.default)(fwdProps, _excluded);
  const {
    renders: renderPlugins
  } = (0, _compile.compile)();
  let resolvedComponent;

  for (const render of renderPlugins) {
    resolvedComponent = render({
      data,
      content,
      excerpt,
      renderers,
      prefix
    });
    if (resolvedComponent) break;
  }

  const {
    props,
    type
  } = resolvedComponent || {};
  const Component = component || type; // TODO: if not resolved component should throw an error?

  return resolvedComponent ? /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    ref: ref
  }, props, componentProps)) : null;
});

exports.Content = Content;
var _default = Content;
exports.default = _default;