"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withNextein = exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _path = _interopRequireDefault(require("path"));

var _webpack = require("webpack");

var _plugins = require("./plugins");

var _compile = require("./plugins/compile");

var _worker = require("./plugins/worker");

const _excluded = ["trailingSlash", "assetPrefix", "nextein"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

const getDefaultConfig = () => ({
  plugins: (0, _plugins.getDefaultPlugins)()
});

const processConfig = function () {
  let nextein = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  const defaultConfig = getDefaultConfig();
  const {
    plugins
  } = typeof nextein === 'function' ? nextein(defaultConfig) : _objectSpread(_objectSpread(_objectSpread({}, nextein), defaultConfig), {}, {
    plugins: [...defaultConfig.plugins, ...(nextein.plugins || [])]
  });
  return {
    plugins: (0, _plugins.processPlugins)(plugins)
  };
};

const withNextein = function () {
  let userConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  const {
    trailingSlash = true,
    assetPrefix = process.env.PUBLIC_URL || undefined,
    nextein
  } = userConfig,
        nextConfig = (0, _objectWithoutProperties2.default)(userConfig, _excluded);
  const nexteinConfig = processConfig(nextein);
  const {
    configs
  } = (0, _compile.compile)();

  let config = _objectSpread(_objectSpread({}, nextConfig), {}, {
    trailingSlash,
    assetPrefix,

    webpack(config, options) {
      config.plugins.push(new _webpack.DefinePlugin({
        'process.env.PUBLIC_URL': JSON.stringify(process.env.PUBLIC_URL || '')
      }), new _webpack.NormalModuleReplacementPlugin(/plugins[/\\]compile[/\\]index.js/, './client.js'), new _webpack.IgnorePlugin({
        resourceRegExp: /^\.\/load$/,
        contextRegExp: /entries$/
      }));
      config.module = _objectSpread(_objectSpread({}, config.module), {}, {
        // Avoid warning from webpack when require has an expression.
        // Which is the case for requiring plugins dynamically.
        exprContextCritical: false
      });
      config.module.rules = [{
        test: /\.js$/,
        include: _path.default.dirname(require.resolve('nextein/dist/plugins/render')),
        use: [options.defaultLoaders.babel, {
          loader: 'nextein/dist/plugins/render/loader',
          options: {
            plugins: nexteinConfig.plugins
          }
        }]
      }, ...config.module.rules];

      if (typeof nextConfig.webpack === 'function') {
        return nextConfig.webpack(config, options);
      }

      return config;
    }

  });

  for (const configPlugin of configs) {
    config = configPlugin(config);
  }

  (0, _worker.runProcessWorker)();
  return config;
};

exports.withNextein = withNextein;
var _default = withNextein;
exports.default = _default;