"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.inCategory = exports.inCategories = void 0;

const inCategory = function (category) {
  let {
    includeSubCategories = false
  } = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return post => {
    const {
      data = post
    } = post; // if there is no post.data, we assume we are working with data object

    const {
      category: postCategory = ''
    } = data;
    const shouldIncludeSub = includeSubCategories || category.endsWith('/*');
    const result = shouldIncludeSub ? postCategory.startsWith(category.replace('/*', '')) : postCategory === category;
    return result;
  };
};

exports.inCategory = inCategory;

const inCategories = function () {
  let categories = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return post => {
    return categories.some(category => inCategory(category)(post));
  };
};

exports.inCategories = inCategories;