"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.load = load;

var _cache = _interopRequireDefault(require("./cache"));

const cache = (0, _cache.default)();
/**
 * Return all entries. If ids is provided return all entries matching __id.
 * @param {String | Array<String>} ids Optional.
 */

async function load(ids) {
  if (!cache.isValid()) {
    await cache.load();
  }

  const entries = cache.get();
  const entriesIds = [].concat(ids).filter(Boolean);

  if (entriesIds.length) {
    return entries.filter(_ref => {
      let {
        data: {
          __id
        }
      } = _ref;
      return entriesIds.includes(__id);
    });
  }

  return entries;
}