"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.compile = compile;

/**
 * THIS FILE IS LOADED BY WEBPACK TO REPLACE compile/index.js in client
 */
function compile() {
  const renderPluginModule = require('nextein/dist/plugins/render');

  const renderPlugins = renderPluginModule.__PLUGINS__;
  const renders = [];

  for (const plugin of renderPlugins) {
    const {
      name,
      options
    } = plugin;
    const render = renderPluginModule[name];

    if (render) {
      renders.push(function () {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return render(options, ...args);
      });
    }
  }

  return {
    renders
  };
}