"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _unified = _interopRequireDefault(require("unified"));

var _remarkParse = _interopRequireDefault(require("remark-parse"));

var _remarkRehype = _interopRequireDefault(require("remark-rehype"));

var _rehypeRaw = _interopRequireDefault(require("rehype-raw"));

var _default = _ref => {
  let {
    remark = [],
    rehype = []
  } = _ref;
  return (0, _unified.default)().use(_remarkParse.default).use(remark.map(mapPlugin)).use(_remarkRehype.default, {
    allowDangerousHtml: true
  }).use(rehype.map(mapPlugin)).use(_rehypeRaw.default);
};

exports.default = _default;

const mapPlugin = p => {
  if (Array.isArray(p)) {
    const [name, options] = p;
    return [require(name), options];
  }

  return require(p);
};