"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.render = render;

var _react = _interopRequireDefault(require("react"));

var _unified = _interopRequireDefault(require("unified"));

var _rehypeStringify = _interopRequireDefault(require("rehype-stringify"));

var _rehypeReact = _interopRequireDefault(require("rehype-react"));

var _unistUtilSelect = require("unist-util-select");

const DEFAULT_EXCERPT = ':root > element[tagName=p]';

const extractExcerpt = options => excerpt => {
  const selector = typeof excerpt === 'string' ? excerpt : options.excerpt || DEFAULT_EXCERPT;
  return () =>
  /* attacher */
  tree => {
    /* transformer */
    if (excerpt) {
      return (0, _unistUtilSelect.select)(selector, tree);
    }

    return tree;
  };
};
/**
 * render
 * @param {Object} options
 * @param {String} options.excerpt Default excerpt selector to be used in Content when excerpt is set to true.
 * It must be a valid `unist-util-select` selector. Default to ':root > element[tagName=p]' (first paragraph).
 * @param {Object} contentConfig
 */


function render(options, _ref) {
  let {
    data,
    content,
    excerpt,
    renderers,
    components,
    prefix = 'entry-'
  } = _ref;

  if (data.mimeType === 'text/markdown') {
    const hast = JSON.parse(JSON.stringify(content));
    const p = (0, _unified.default)().use(extractExcerpt(options)(excerpt)).use(_rehypeStringify.default).use(_rehypeReact.default, {
      createElement: _react.default.createElement,
      prefix,
      components: components || renderers
    });
    return p.stringify(p.runSync(hast));
  }
}